package com.pixelized.server.lwa.server.rest.character

import com.pixelized.server.lwa.server.Engine
import com.pixelized.server.lwa.server.exception.MissingParameterException
import com.pixelized.server.lwa.utils.extentions.characterSheetId
import com.pixelized.server.lwa.utils.extentions.exception
import com.pixelized.server.lwa.utils.extentions.param
import com.pixelized.shared.lwa.protocol.rest.APIResponse
import com.pixelized.shared.lwa.protocol.websocket.CharacterSheetEvent
import io.ktor.server.response.respond
import io.ktor.server.routing.RoutingContext

fun Engine.putCharacterFatigue(): suspend RoutingContext.() -> Unit {
    return {
        try {
            // get the query parameter
            val characterSheetId = call.queryParameters.characterSheetId
            val fatigue: Int = call.queryParameters.param(
                name = "fatigue",
                code = APIResponse.ErrorCode.Fatigue,
            )
            // fetch the character sheet
            val characterSheet = characterService.character(characterSheetId)
                ?: error("CharacterSheet with id:$characterSheetId not found.")
            // Update the character damage
            characterService.updateFatigue(
                characterSheetId = characterSheetId,
                fatigue = fatigue
            )
            // API & WebSocket responses.
            call.respond(
                message = APIResponse.success()
            )
            webSocket.emit(
                value = CharacterSheetEvent.UpdateFatigue(
                    timestamp = System.currentTimeMillis(),
                    characterSheetId = characterSheetId,
                    oldValue = characterSheet.fatigue,
                    fatigue = fatigue,
                )
            )
        } catch (exception: Exception) {
            call.exception(
                exception = exception
            )
        }
    }
}